local addonName, ns = ...
local _G = _G
local addon = ns.addon
local moduleTemplate = {}
addon.moduleTemplate = moduleTemplate
local setfenv = _G.setfenv
setfenv(1, moduleTemplate)

local assert, error = _G.assert, _G.error


local AceConfig, AceConfigDialog
do
    local LibStub = _G.LibStub
    AceConfig = LibStub:GetLibrary('AceConfig-3.0')
    AceConfigDialog =  LibStub:GetLibrary('AceConfigDialog-3.0')
end

moduleTemplate.optionsTable = {
    name = nil,
    type = 'group',
    handler = nil,
    args = {
--        enable = {
--            name = "Enable",
--            desc = "Enable this bar.",
--            type = "toggle",
--            get = 'getEnable',
--            set = 'setEnable'
--        },
    },
}

--[=[
-- Enabling and disabling is a special setting, as this calls AceAddon:(En|Dis)able
--]=]
function moduleTemplate:getEnable(info)
    return self:getOptions().enable
end

function moduleTemplate:setEnable(info,value)
    self:getOptions().enable = value
    if value then
        self:Enable()
    else
        self:Disable()
    end
end

moduleTemplate.defaults = {
    enable = false,
}

--- Called when the module is loaded
-- (Ace3 does this)
function moduleTemplate:OnInitialize()
    self.cache = {}
    local name = self:GetName()

    -- Make optionstable usable
    self.optionsTable.name = name
    self.optionsTable.handler = self
    assert(self.optionsTable.type)
    addon.defaults.char[name] = self.defaults

    AceConfig:RegisterOptionsTable(name, self.optionsTable)
    self.optionsFrame = AceConfigDialog:AddToBlizOptions(name, name, addonName)
end

function moduleTemplate:getOptions()
    local name = self:GetName()
    addon.db.char[name] = addon.db.char[name] or ns.deepCopy(self.defaults)
    return addon.db.char[name]
end