local addonName, ns = ...
local _G = _G
local setfenv = _G.setfenv
local addon = ns.addon
setfenv(1, addon)

local assert = _G.assert

function addon:createModule(name, template, ...)
    -- Note that AceAddon3:NewModule creates a shallow copy of the template.
    -- This is not sufficient, hence we need to make a deepcopy first
    local templateCopy = ns.deepCopy(template)
    local module = addon:NewModule(name, templateCopy, 'AceHook-3.0',...)
    module.parent = self
    self:registerModule(name, module)
    return module
end

function addon:registerModule(name, module)
    self.modules = self.modules or {}
    self.modules[name] = module
    assert(module.optionsTable, name .. " has no optionsTable")
    self.optionsTable.args[name] = {
        name = name,
        desc = module.optionsTable.desc,
        type = "toggle",
        get = 'getEnable',
        set = 'setEnable',
        handler = module,
    }
end